'''
>>> option_count(MENU)
26
>>> most_ingredients(MENU)
'California Burger: 9'
>>> most_common(MENU)
'lettuce: 22'
>>> unique_ingredients(MENU)
35
'''
def option_count(menu):
    return len(menu)

def most_ingredients(menu):
    big = None
    for name, ings in menu.iteritems():
        if big is None or big[1] < len(ings):
            big = (name, len(ings))
    return '%s: %s' % big

def ingredient_counts(menu):
    counts = {}
    for ings in menu.values():
        for ing in ings:
            counts.setdefault(ing, 0)
            counts[ing] += 1
    return counts

def get2(t):
    return t[1]

def most_common(menu):
    count_list = sorted(ingredient_counts(menu).iteritems(),
            key=get2,
            reverse=True)
    return '%s: %s' % count_list[0]

def unique_ingredients(menu):
    return len(ingredient_counts(menu))

MENU = {
  'BBQ Beef': ['chopped beef steak', 'bbq sauce', 'mayonnaise'],
  'Bacon Burger': [ 'bacon',
                    'mustard',
                    'mayonnaise',
                    'onions',
                    'pickles',
                    'tomato',
                    'lettuce'],
  'California Burger': [ 'bacon',
                         'pepper jack',
                         'jalapenos',
                         'mustard',
                         'mayonnaise',
                         'onions',
                         'pickles',
                         'tomato',
                         'lettuce'],
  'California Chicken': [ 'chicken breast',
                          'mayonnaise',
                          'pepper jack',
                          'bacon',
                          'jalapenos',
                          'tomato',
                          'lettuce'],
  'Charbroiled Beef Hot Dog': [ 'mustard',
                                'mayonnaise',
                                'onions',
                                'pickles',
                                'tomato',
                                'lettuce'],
  'Charbroiled Chicken Breast': [ 'marinated filet chicken',
                                  'mayonnaise',
                                  'tomato',
                                  'lettuce'],
  'Club Sandwich': [ 'ham',
                     'turkey',
                     'bacon',
                     'cheese',
                     'mayonnaise',
                     'tomato',
                     'lettuce'],
  'Double Burger': [ 'mustard',
                     'onions',
                     'pickles',
                     'tomato',
                     'lettuce'],
  'Garden Burger': ['veggie burger', 'onions', 'pickles', 'tomato', 'lettuce'],
  'Grilled Corned Beef': [ 'mustard',
                           'mayonnaise',
                           'onions',
                           'pickles',
                           'tomato',
                           'lettuce'],
  'Grilled Ham & Cheese': [ 'mustard',
                            'mayonnaise',
                            'onions',
                            'pickles',
                            'tomato',
                            'lettuce'],
  'Grilled Pastrami': [ 'mustard',
                        'mayonnaise',
                        'onions',
                        'pickles',
                        'tomato',
                        'lettuce'],
  'Guacamole Burger': [ 'avocado',
                        'mustard',
                        'mayonnaise',
                        'onions',
                        'pickles',
                        'tomato',
                        'lettuce'],
  'Guacamole Chicken': [ 'chicken breast',
                         'avocado',
                         'mayonnaise',
                         'onions',
                         'tomato',
                         'lettuce'],
  'Hamburger Steak Sandwich': [ 'two beef patties',
                                'grilled onions',
                                'mushrooms',
                                'pepper',
                                'jack cheese on a roll'],
  'Hot Link': [ 'beef link',
                'mustard',
                'mayonnaise',
                'onions',
                'pickles',
                'tomato',
                'lettuce'],
  'Mushroom Burger': [ 'mushrooms',
                       'mustard',
                       'mayonnaise',
                       'onions',
                       'pickles',
                       'tomato',
                       'lettuce'],
  'Old Fashioned B.L.T': ['bacon', 'mayonnaise', 'tomato', 'lettuce'],
  'Pepper Steak': [ 'marinated beef',
                    'red pepper',
                    'onions',
                    'mushroom',
                    'tomato',
                    'lettuce'],
  'Philly Cheese Steak': [ 'chopped tender lean steak',
                           'mayonnaise',
                           'provolone cheese'],
  'Polish Sausage': ['mustard', 'mayonnaise', 'onions', 'tomato', 'lettuce'],
  'Roast Beef Melt': [ 'roast beef',
                       'choice of cheese',
                       'pickles',
                       'tomato',
                       'lettuce'],
  'Single Burger': [ 'mustard',
                     'mayonnaise',
                     'onions',
                     'pickles',
                     'tomato',
                     'lettuce'],
  'Steak Sandwich': [ 'sliced tender beef',
                      'mushrooms',
                      'grilled onions',
                      'mayonnaise',
                      'tomato',
                      'lettuce'],
  'Tuna Melt': [ 'fresh tuna',
                 'melted cheese',
                 'mayonnaise',
                 'onions',
                 'lettuce'],
  'Turkey Melt with Bacon': [ 'fresh cut turkey',
                              'bacon',
                              'melted cheese',
                              'mayonnaise']}

if __name__ == '__main__':
    import doctest
    doctest.testmod()
